/* p_arbeit_2.c
 *
 * Verhalten von Pointern
 */

#include <stdio.h>

int main() {
  // Definitionen
  int alpha;
  int * pointer1;
  int * pointer2;

  // erste Ausgabe
  printf("\nvor den Initialisierungen:\n");
  printf("alpha: %d\n", alpha);
  printf("pointer1: %p\t pointer2: %p\n", pointer1, pointer2);
  printf("*pointer1: %d\t *pointer2: %d\n", *pointer1, *pointer2);

  // Initialisierungen
  alpha = 42;
  pointer1 = &alpha;	// Referenzieren von alpha
  pointer2 = NULL;	// NULL-Pointer

  // zweite Ausgabe
  printf("\nnach den Initialisierungen:\n");
  printf("alpha: %d\n", alpha);
  printf("pointer1: %p\t pointer2: %p\n", pointer1, pointer2);
//  printf("*pointer1: %d\t *pointer2: %d\n", *pointer1, *pointer2);
  printf("*pointer1: %d\n", *pointer1);

  // Zuweisung der Adresse von pointer1 an pointer2
  pointer2 = pointer1;	

  // dritte Ausgabe
  printf("\nnach Zuweisung pointer2 = pointer1:\n");
  printf("alpha: %d\n", alpha);
  printf("pointer1: %p\t pointer2: %p\n", pointer1, pointer2);
  printf("*pointer1: %d\t *pointer2: %d\n", *pointer1, *pointer2);

  // Aendern des Wertes von alpha durch Dereferenzieren
  *pointer2 = -99;
  
  // vierte Ausgabe
  printf("\nnach Modifikation von alpha:\n");
  printf("alpha: %d\n", alpha);
  printf("pointer1: %p\t pointer2: %p\n", pointer1, pointer2);
  printf("*pointer1: %d\t *pointer2: %d\n", *pointer1, *pointer2);

  printf("\n");
  return 0;
}
